module Partoche.Partitions.Jigue where

import Euterpea

partition :: Maybe InstrumentName -> [Music Pitch] -> Music Pitch
partition maybeInstrument ms = foldr1 (:+:) ms'
  where
    ms' = case maybeInstrument of
           Nothing -> ms
           Just instrument -> map (\n -> changeInstrument instrument n) ms


tour1 o = [ d o en
          , fs o en
          , b (o+1) en
          , a (o+1) qn
          , b (o+1) en
          ]

tourbillonJigue o = mouvement1 ++ mouvement1 ++ mouvement2 ++ mouvement2
  where
    mouvement1 = mesure1 ++ mesure2 ++ mesure3 ++ mesure4
    mouvement2 = mesure5 ++ mesure6 ++ mesure7 ++ mesure8
    
    mesure1  = tour1 o ++ tour1 o
      where
        tour1 o = [ d o en
                  , fs o en
                  , b (o+1) en
                  , a (o+1) qn
                  , b (o+1) en
                  ]
    
    mesure2  = (replicate 3 (e o en))
              ++ [a (o+1) qn]
              ++ (replicate 3 (e  o    en))
              ++ (replicate 3 (a (o+1) en))
    
    mesure3  = mesure1

    mesure4  = [line [e o en, fs o en, g o en]]
               ++ [line [ a (o+1) en
                        , b (o+1) en
                        , cs (o+1) en
                        ]
                  ]
               ++ [ d (o+1) dqn
                  , d (o+1)  qn
                  , a (o+1) en
                  ]

    mesure5' = [line $ replicate 3 (d (o+1) en)]
                               ++ [d (o+1) qn]
                               ++ [e (o+1) en]
                               ++ [fs (o+1) qn]
                               ++ [d (o+1) en]

    mesure5 = mesure5' ++ [a (o+1) dqn]

    mesure7 = mesure5'
              ++ [a (o+1) qn]
              ++ [fs o     en]

    mesure6 = [fs (o+1) dqn] -- add infini here
               ++ [ line [ fs (o+1) en
                         , e (o+1) en
                         , d (o+1) en
                         ]
                  ]
               ++ [ cs (o+1) qn ]
               ++ [ d (o+1) en ]
               ++ [ line [ e (o+1) en
                         , d (o+1) en
                         , cs (o+1) en
                         ]
                  ]

    mesure8 = [ line [ e o en
                        , fs o en
                        , g o en
                        ]
                 ]
              ++ [ line [ a (o+1) en
                        , b (o+1) en
                        , cs (o+1) en
                        ]
                 ]
              ++ [ d (o+1) dqn
                 , d (o+1) qn
                 , a o     en
                 ]

mesure4 o  = [line [e o en, fs o en, g o en]]
               ++ [line [ a (o+1) en
                        , b (o+1) en
                        , cs (o+1) en
                        ]
                  ]
               ++ [ d (o+1) dqn
                  , d (o+1)  qn
                  , a (o+1) en
                  ]


bolero o = ta 
        ++ ta 
        ++ [ chord [e (o+1) dden, e (o+1) en], e (o+1) dden]
        ++ ta
        ++ ta
  where
    ta = [ chord [e (o+1) dden, a (o+1) en]
           , line [ e (o+1) en
                  , e (o+1) en
                  , e (o+1) en
                  ]
           ]





-- foldl (:+:) (g 7 bn) $ take 5 $ repeat veloBrouillard
veloBrouillard = (:=:) velo brouillard

brouillard = foldl (:+:) (a 1 wn) $ take 10 $ repeat (a 1 wn)

velo :: Music Pitch
velo = foldl (:+:) (a 4 bn) (velo ++ (reverse velo))
  where
    velo = [a 4 en, b 4 en, d 5 en, e 5 en, b 5 en, e 5 en, a 5 en, a 4 wn, b 4 en, d 5 en, a 1 bn]



